﻿using System.Linq;
using System.Web.Mvc;
using Microsoft.Reporting.WebForms;

namespace _341284_Export_RDLC_PDF.Controllers
{
    public class HomeController : Controller
    {
        // GET: /Home/Export
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult Export()
        {
            NorthwindEntities entities = new NorthwindEntities();
            LocalReport localReport = new LocalReport()
            {
                ReportPath = Server.MapPath("~/CustomerReport.rdlc")
            };
            ReportDataSource rds = new ReportDataSource("Customers", entities.Customers.ToList());
            localReport.DataSources.Add(rds);

            string reportType = "PDF";
            string mimeType, encoding, fileNameExtension;

            string deviceInfo =
                            "<DeviceInfo>" +
                            "   <OutputFormat>" + reportType + "</OutputFormat>" +
                            "   <PageWidth>8.5in</PageWidth>" +
                            "   <PageHeight>11in</PageHeight>" +
                            "   <MarginTop>0.5in</MarginTop>" +
                            "   <MarginLeft>0in</MarginLeft>" +
                            "   <MarginRight>0in</MarginRight>" +
                            "   <MarginBottom>0in</MarginBottom>" +
                            "</DeviceInfo>";

            Warning[] warnings;
            string[] streams;
            byte[] renderedBytes = localReport.Render(reportType, deviceInfo, out mimeType, out encoding,
                                                        out fileNameExtension, out streams, out warnings);

            return File(renderedBytes, mimeType, "Test.pdf");
        }
    }
}
